const loader = document.querySelector('.loading');
const countryName = document.getElementById('name')
const region = document.getElementById('region')
const subregion = document.getElementById('subregion')
const capital = document.getElementById('capital')
const flag = document.getElementById('flag')
const button = document.getElementById('show')
const userInput = document.getElementById('country_name')
const infoToshow = document.querySelector('.show');
let name_to_find = 'Kazakhstan'


const request = (config) => {
    loader.style.display = 'flex'
    const { method, path, success, error } = config;
    return new Promise((resolve, reject) => {
        
    
    const xml = new XMLHttpRequest();
    xml.addEventListener('load', () => {
        if (xml.status >= 200 || xml.status > 300) {
            const result = JSON.parse(xml.responseText);
            resolve(result)
        }
        else {
            reject(this.status)
        }
        

    });
    loader.style.display = 'none'
    xml.addEventListener('error', () => {
        error('network error');
    })
    xml.addEventListener('timeout', () => {
        error('server response is late')
    })
    xml.open(method, path);
    xml.send();
})
}

const processResult = (result) => {

    const items = createTree(result[0])
    infoToshow.append(items)
    loader.style.display = 'none'
}

const errorHandler = (msg) => {
    alert(msg)
    console.error(msg)
}


const createTree = (data) => {
    const ul = document.createElement('ul')
    for (item in data) {
        const li = document.createElement('li')
        if (false) {
            const flagImg = document.createElement('img');
            flagImg.setAttribute('src', `${item.flag}`);
            flagImg.style = 'width: 150px'
            li.append(flagImg)
        }
        else {
            if (Array.isArray(data)) {
                if (typeof data[item] === 'object') {
                    const innerUl = createTree(data[item])
                    li.append(innerUl)
                } else {
                    li.append(`${data[item]}`)
                }
            } else {
                if (Array.isArray(data[item])) {
                    li.innerHTML = `<b>${item}:</b> \n`
                    const innerUl = createTree(data[item])
                    li.append(innerUl)
                } else {
                    if ((typeof data[item] === 'object')) {
                        li.innerHTML = `<b>${item}:</b> \n`
                        const innerUl = createTree(data[item])
                        li.append(innerUl)
                    } else {
                        li.innerHTML = `<b>${item}:</b> ${data[item]}`
                    }
                    
                }
            }
        }

        ul.append(li)

    }
    return ul
}



const showInfo = () => {
    if (userInput.value) {
        name_to_find = userInput.value
    }
    const config = {
        method: "GET",
        path: `https://restcountries.com/v2/name/${name_to_find}`,

    }
    request(config)
    .then(processResult)
    .catch(errorHandler)
        
    infoToshow.style.display = 'block'
}
button.addEventListener('click', showInfo)
